LeetCode hot100-52-G

java 复制代码
994. 腐烂的橘子
在给定的 m x n 网格 grid 中,每个单元格可以有以下三个值之一:

    值 0 代表空单元格;
    值 1 代表新鲜橘子;
    值 2 代表腐烂的橘子。

每分钟,腐烂的橘子 周围 4 个方向上相邻 的新鲜橘子都会腐烂。

返回 直到单元格中没有新鲜橘子为止所必须经过的最小分钟数。如果不可能,返回 -1 。

官方答案看不懂,没注释。找到个好一点能看懂的解答

https://leetcode.cn/problems/rotting-oranges/solutions/2773461/duo-yuan-bfsfu-ti-dan-pythonjavacgojsrus-yfmh/?envType=study-plan-v2\&envId=top-100-liked

代码是这个网址评论区的

思路bfs。将所有腐烂的句子入队列。然后每次循环都将队列弹出至空,并将这次传染的所有橘子入队列。也就是将同一分钟腐烂的同时出队,下一分钟腐烂的橘子同时入队。很像二叉树层次遍历的感觉。

最初ans=-1是因为最后一次腐烂完的橘子入队后,还需要循环一次把队列清空,这时候ans+1了,但是它清空之后没有能腐烂的橘子了,所以多加了1,最初就用的-1. 因为这个-1的存在还需要Math.max(res, 0),最初就没有腐烂的橘子时ans一直是-1,其实答案是0.

java 复制代码
class Solution {
    static int[][] changes = new int[][] { { -1, 0 }, { 1, 0 }, { 0, 1 }, { 0, -1 } };

    public int orangesRotting(int[][] grid) {
        int m = grid.length;
        int n = grid[0].length;

        // 坏橘子队列 [i,j]
        Deque<int[]> queue = new ArrayDeque<>();
        // 好橘子数量
        int goodCount = 0;
        // 遍历所有橘子
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                int x = grid[i][j];
                if (x == 2) {
                    queue.add(new int[] { i, j });
                } else if (x == 1) {
                    goodCount++;
                }
            }
        }
        int res = -1;
        // BFS遍历
        while (!queue.isEmpty()) {
            int size = queue.size();
            while (size-- > 0) {
                int[] p = queue.poll();
                int x = p[0];
                int y = p[1];

                for (int i = 0; i < changes.length; i++) {
                    int nx = x + changes[i][0];
                    int ny = y + changes[i][1];
                    // 向四周污染
                    if (nx >= 0 && nx <= m - 1 && ny >= 0 && ny <= n - 1 && grid[nx][ny] == 1) {
                        grid[nx][ny] = 2;
                        // 将新的坏橘子放入队列
                        queue.add(new int[] { nx, ny });
                        goodCount--;
                    }
                }
            }
            res++;
        }
        return goodCount == 0 ? Math.max(res, 0) : -1;
    }
}
相关推荐
一去不复返的通信er1 小时前
力扣-图论-岛屿数量
算法·leetcode·图论
考研保研资料分享3 小时前
985工科跨保上财应用统计:数学笔试、匿名面试与机试复盘
面试·职场和发展
程序 代码狂人4 小时前
切片表与分区表的区别(数据开发面试版)
java·大数据·开发语言·数据仓库·算法
HDU-Dade5 小时前
【校招笔试真题】简要介绍 Self-Attention 的前沿算法
人工智能·算法
Xin7706 小时前
LeetCode 79. 单词搜索(DFS 回溯法)
leetcode
小郎君6587 小时前
Vue keep-alive 切标签后滚动位置回顶?因为 onDeactivated 里读到的 scrollTop 是 0
算法
邵奈一7 小时前
GPT-6.1 Terra速度是Sol的3倍,价格减半
算法
RaaS1007 小时前
Node.js Brotli RCE 漏洞自查指南:fetch、undici、axios 都在影响面,三分钟确认你的版本
人工智能·深度学习·算法
shehuiyuelaiyuehao8 小时前
算法56,重排链表
数据结构·算法·链表